<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:xalan="http://xml.apache.org/xalan"
                xmlns:x="http://www.w3.org/TR/xpath"
                xmlns="http://www.w3.org/TR/xpath"
                exclude-result-prefixes="xalan x">
    <xsl:output method="xml" indent="yes" xalan:indent-amount="4"/>

    <xsl:template match="/x:XPath">
        <xsl:copy>
            <xsl:apply-templates select="(x:PathExpr|x:UnaryExpr|x:UnionExpr|x:OrExpr|x:AndExpr)[1]"/>
        </xsl:copy>
    </xsl:template>

    <xsl:template match="x:AndExpr">
        <XPath>
            <xsl:apply-templates select="(x:PathExpr|x:UnaryExpr|x:UnionExpr|x:OrExpr|x:AndExpr)[1]" mode="CHILDREN_ONLY"/>
        </XPath>
        <xsl:apply-templates select="(x:PathExpr|x:UnaryExpr|x:UnionExpr|x:OrExpr|x:AndExpr)[2]"/>
    </xsl:template>

    <xsl:template match="x:PathExpr">
        <XPath>
            <xsl:apply-templates select="self::x:PathExpr" mode="CHILDREN_ONLY"/>
        </XPath>
    </xsl:template>
    <xsl:template match="x:PathExpr" mode="CHILDREN_ONLY">
        <xsl:copy-of select="."/>
        <xsl:copy-of select="following-sibling::x:*[1][not(contains('PathExpr|UnaryExpr|UnionExpr|OrExpr|AndExpr',local-name()))]"/>
    </xsl:template>

    <xsl:template match="x:*">
        <xsl:copy-of select="."/>
    </xsl:template>
</xsl:stylesheet>